Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
18 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
23 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
24 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
25 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
26 c3754a5b 2019-05-10 stsp
27 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
28 7b67836a 2019-05-10 stsp
29 f6cae3ed 2020-09-13 naddy git_init()
30 0e673013 2019-01-02 stsp {
31 0b2899f8 2019-08-18 stsp git init -q "$1"
32 0e673013 2019-01-02 stsp }
33 0e673013 2019-01-02 stsp
34 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
35 b32c4525 2020-01-05 stsp {
36 b32c4525 2020-01-05 stsp local repo="$1"
37 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
38 b32c4525 2020-01-05 stsp (cd $repo && git repack -a -q)
39 b32c4525 2020-01-05 stsp fi
40 b32c4525 2020-01-05 stsp }
41 b32c4525 2020-01-05 stsp
42 f6cae3ed 2020-09-13 naddy git_commit()
43 0e673013 2019-01-02 stsp {
44 0e673013 2019-01-02 stsp local repo="$1"
45 0e673013 2019-01-02 stsp shift
46 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
47 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
48 0e673013 2019-01-02 stsp }
49 0e673013 2019-01-02 stsp
50 f6cae3ed 2020-09-13 naddy git_rm()
51 512f0d0e 2019-01-02 stsp {
52 512f0d0e 2019-01-02 stsp local repo="$1"
53 512f0d0e 2019-01-02 stsp shift
54 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
55 512f0d0e 2019-01-02 stsp }
56 512f0d0e 2019-01-02 stsp
57 f6cae3ed 2020-09-13 naddy git_show_head()
58 9c4b8182 2019-01-02 stsp {
59 9c4b8182 2019-01-02 stsp local repo="$1"
60 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
61 9c4b8182 2019-01-02 stsp }
62 9c4b8182 2019-01-02 stsp
63 f6cae3ed 2020-09-13 naddy git_show_branch_head()
64 db32465d 2020-02-07 stsp {
65 db32465d 2020-02-07 stsp local repo="$1"
66 db32465d 2020-02-07 stsp local branch="$2"
67 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
68 db32465d 2020-02-07 stsp }
69 db32465d 2020-02-07 stsp
70 db32465d 2020-02-07 stsp
71 f6cae3ed 2020-09-13 naddy git_show_author_time()
72 bcb49d15 2019-08-14 stsp {
73 bcb49d15 2019-08-14 stsp local repo="$1"
74 01073a5d 2019-08-22 stsp local object="$2"
75 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
76 bcb49d15 2019-08-14 stsp }
77 bcb49d15 2019-08-14 stsp
78 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
79 8e7bd50a 2019-08-22 stsp {
80 8e7bd50a 2019-08-22 stsp local repo="$1"
81 8e7bd50a 2019-08-22 stsp local tag="$2"
82 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
83 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
84 8e7bd50a 2019-08-22 stsp }
85 8e7bd50a 2019-08-22 stsp
86 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
87 818c7501 2019-07-11 stsp {
88 818c7501 2019-07-11 stsp local repo="$1"
89 70551d57 2020-04-24 stsp local commit="$2"
90 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
91 818c7501 2019-07-11 stsp }
92 818c7501 2019-07-11 stsp
93 f6cae3ed 2020-09-13 naddy git_show_tree()
94 03415a1a 2019-06-02 stsp {
95 03415a1a 2019-06-02 stsp local repo="$1"
96 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
97 03415a1a 2019-06-02 stsp }
98 03415a1a 2019-06-02 stsp
99 f6cae3ed 2020-09-13 naddy trim_obj_id()
100 818c7501 2019-07-11 stsp {
101 9439a990 2020-09-16 naddy local trimcount=$1
102 9439a990 2020-09-16 naddy local id=$2
103 818c7501 2019-07-11 stsp
104 9439a990 2020-09-16 naddy local pat=""
105 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
106 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
107 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
108 818c7501 2019-07-11 stsp done
109 818c7501 2019-07-11 stsp
110 818c7501 2019-07-11 stsp echo ${id%$pat}
111 818c7501 2019-07-11 stsp }
112 818c7501 2019-07-11 stsp
113 f6cae3ed 2020-09-13 naddy git_commit_tree()
114 03415a1a 2019-06-02 stsp {
115 03415a1a 2019-06-02 stsp local repo="$1"
116 03415a1a 2019-06-02 stsp local msg="$2"
117 03415a1a 2019-06-02 stsp local tree="$3"
118 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
119 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
120 03415a1a 2019-06-02 stsp }
121 03415a1a 2019-06-02 stsp
122 f0fd0aaf 2021-09-14 stsp git_fsck()
123 f0fd0aaf 2021-09-14 stsp {
124 f0fd0aaf 2021-09-14 stsp local testroot="$1"
125 f0fd0aaf 2021-09-14 stsp local repo="$2"
126 f0fd0aaf 2021-09-14 stsp
127 f0fd0aaf 2021-09-14 stsp (cd $repo && git fsck --strict \
128 f0fd0aaf 2021-09-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
129 f0fd0aaf 2021-09-14 stsp ret="$?"
130 f0fd0aaf 2021-09-14 stsp if [ "$ret" != "0" ]; then
131 f0fd0aaf 2021-09-14 stsp echo -n "git fsck: "
132 f0fd0aaf 2021-09-14 stsp cat $testroot/fsck.stderr
133 f0fd0aaf 2021-09-14 stsp echo "git fsck failed; leaving test data in $testroot"
134 f0fd0aaf 2021-09-14 stsp return 1
135 f0fd0aaf 2021-09-14 stsp fi
136 f0fd0aaf 2021-09-14 stsp
137 f0fd0aaf 2021-09-14 stsp return 0
138 f0fd0aaf 2021-09-14 stsp }
139 f0fd0aaf 2021-09-14 stsp
140 f6cae3ed 2020-09-13 naddy make_test_tree()
141 0e673013 2019-01-02 stsp {
142 0e673013 2019-01-02 stsp repo="$1"
143 0e673013 2019-01-02 stsp
144 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
145 0e673013 2019-01-02 stsp echo beta > $repo/beta
146 0e673013 2019-01-02 stsp mkdir $repo/gamma
147 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
148 0e673013 2019-01-02 stsp mkdir $repo/epsilon
149 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
150 0e673013 2019-01-02 stsp }
151 0e673013 2019-01-02 stsp
152 f6cae3ed 2020-09-13 naddy make_single_file_repo()
153 e7303626 2020-05-14 stsp {
154 e7303626 2020-05-14 stsp repo="$1"
155 e7303626 2020-05-14 stsp file="$2"
156 e7303626 2020-05-14 stsp
157 e7303626 2020-05-14 stsp mkdir $repo
158 e7303626 2020-05-14 stsp git_init $repo
159 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
160 e7303626 2020-05-14 stsp (cd $repo && git add .)
161 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
162 e7303626 2020-05-14 stsp }
163 e7303626 2020-05-14 stsp
164 f6cae3ed 2020-09-13 naddy get_loose_object_path()
165 e7303626 2020-05-14 stsp {
166 e7303626 2020-05-14 stsp local repo="$1"
167 e7303626 2020-05-14 stsp local id="$2"
168 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
169 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
170 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
171 e7303626 2020-05-14 stsp }
172 e7303626 2020-05-14 stsp
173 f6cae3ed 2020-09-13 naddy get_blob_id()
174 3ce1b845 2019-07-15 stsp {
175 3ce1b845 2019-07-15 stsp repo="$1"
176 3ce1b845 2019-07-15 stsp tree_path="$2"
177 3ce1b845 2019-07-15 stsp filename="$3"
178 3ce1b845 2019-07-15 stsp
179 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
180 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
181 3ce1b845 2019-07-15 stsp }
182 3ce1b845 2019-07-15 stsp
183 f6cae3ed 2020-09-13 naddy test_init()
184 0e673013 2019-01-02 stsp {
185 0e673013 2019-01-02 stsp local testname="$1"
186 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
187 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
188 0e673013 2019-01-02 stsp echo "No test name provided" >&2
189 0e673013 2019-01-02 stsp return 1
190 0e673013 2019-01-02 stsp fi
191 e5a14fe3 2020-10-01 stsp local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
192 0e673013 2019-01-02 stsp mkdir $testroot/repo
193 0e673013 2019-01-02 stsp git_init $testroot/repo
194 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
195 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
196 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
197 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
198 4a1ddfc2 2019-01-12 stsp fi
199 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
200 0e673013 2019-01-02 stsp echo "$testroot"
201 0e673013 2019-01-02 stsp }
202 0e673013 2019-01-02 stsp
203 f6cae3ed 2020-09-13 naddy test_cleanup()
204 0e673013 2019-01-02 stsp {
205 0e673013 2019-01-02 stsp local testroot="$1"
206 fe7842f5 2019-07-14 stsp
207 f0fd0aaf 2021-09-14 stsp git_fsck $testroot $testroot/repo
208 fe7842f5 2019-07-14 stsp ret="$?"
209 fe7842f5 2019-07-14 stsp if [ "$ret" != "0" ]; then
210 f0fd0aaf 2021-09-14 stsp return $ret
211 fe7842f5 2019-07-14 stsp fi
212 fe7842f5 2019-07-14 stsp
213 0e673013 2019-01-02 stsp rm -rf "$testroot"
214 0e673013 2019-01-02 stsp }
215 0e673013 2019-01-02 stsp
216 f6cae3ed 2020-09-13 naddy test_parseargs()
217 7fb414ae 2020-08-08 stsp {
218 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
219 6c8da0c6 2020-10-03 naddy case $flag in
220 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
221 6c8da0c6 2020-10-03 naddy ;;
222 6c8da0c6 2020-10-03 naddy r) export GOT_TEST_ROOT=$OPTARG
223 6c8da0c6 2020-10-03 naddy ;;
224 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
225 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
226 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
227 6c8da0c6 2020-10-03 naddy exit 2
228 6c8da0c6 2020-10-03 naddy ;;
229 7fb414ae 2020-08-08 stsp esac
230 7fb414ae 2020-08-08 stsp done
231 6c8da0c6 2020-10-03 naddy } >&2
232 7fb414ae 2020-08-08 stsp
233 f6cae3ed 2020-09-13 naddy run_test()
234 0e673013 2019-01-02 stsp {
235 0e673013 2019-01-02 stsp testfunc="$1"
236 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
237 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
238 7fb414ae 2020-08-08 stsp fi
239 0e673013 2019-01-02 stsp $testfunc
240 0e673013 2019-01-02 stsp }
241 0e673013 2019-01-02 stsp
242 f6cae3ed 2020-09-13 naddy test_done()
243 0e673013 2019-01-02 stsp {
244 0e673013 2019-01-02 stsp local testroot="$1"
245 0e673013 2019-01-02 stsp local result="$2"
246 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
247 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
248 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
249 7fb414ae 2020-08-08 stsp echo "ok"
250 7fb414ae 2020-08-08 stsp fi
251 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
252 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
253 3941b73a 2019-05-14 stsp echo "$result"
254 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
255 0e673013 2019-01-02 stsp else
256 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
257 0e673013 2019-01-02 stsp fi
258 0e673013 2019-01-02 stsp }